##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic compression utilities                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate the generation of          ##
## compressed files and their inclusion in users' projects.               ##
############################################################################

## COMPRESSION EXAMPLE (Uncomment lines to use)
##

## First 3 calls to ADD2PACK add enemy, hero and background
## graphics (previously converted to binary data) into the 
## compressed group 'mygraphics'. After that, call to PACKZX7B
## compresses all the data and generates an array with the result
## that is placed in src/mygraphics.c & src/mygraphics.h, ready
## to be included and used by other modules.
##
#$(eval $(call ADD2PACK,mygraphics,gfx/enemy.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/hero.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/background.bin))
#$(eval $(call PACKZX7B,mygraphics,src/))

#$(eval $(call ADD2PACK,lvl1_pack,src/lvl1.bin))
#$(eval $(call ADD2PACK,lvl1_pack,src/tilesetV1.bin))
#$(eval $(call PACKZX7B,lvl1_pack,src/))

$(eval $(call ADD2PACK,transicion_pack,src/imbin/transicion.bin))
$(eval $(call PACKZX7B,transicion_pack,src/comprimido))

$(eval $(call ADD2PACK,Controles_pack,src/imbin/Controles.bin))
$(eval $(call PACKZX7B,Controles_pack,src/comprimido))

$(eval $(call ADD2PACK,endgame_pack,src/imbin/endgame.bin))
$(eval $(call PACKZX7B,endgame_pack,src/comprimido))
############################################################################
$(eval $(call ADD2PACK,lvl0_pack,src/niveles/mapa0.bin))
$(eval $(call PACKZX7B,lvl0_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl1_pack,src/niveles/mapa1.bin))
$(eval $(call PACKZX7B,lvl1_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl2_pack,src/niveles/mapaRa4.bin))
$(eval $(call PACKZX7B,lvl2_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl3_pack,src/niveles/mapa2.bin))
$(eval $(call PACKZX7B,lvl3_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl4_pack,src/niveles/mapadash2.bin))
$(eval $(call PACKZX7B,lvl4_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl5_pack,src/niveles/maf2.bin))
$(eval $(call PACKZX7B,lvl5_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl6_pack,src/niveles/mapa3.bin))
$(eval $(call PACKZX7B,lvl6_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl7_pack,src/niveles/mapa7.bin))
$(eval $(call PACKZX7B,lvl7_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl8_pack,src/niveles/mapa5.bin))
$(eval $(call PACKZX7B,lvl8_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl9_pack,src/niveles/mapaRa8.bin))
$(eval $(call PACKZX7B,lvl9_pack,src/comprimido))

$(eval $(call ADD2PACK,lvl10_pack,src/niveles/flechas0.bin))
$(eval $(call PACKZX7B,lvl10_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl11_pack,src/niveles/flechas1.bin))
$(eval $(call PACKZX7B,lvl11_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl12_pack,src/niveles/mapaRa5.bin))
$(eval $(call PACKZX7B,lvl12_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl13_pack,src/niveles/mapaRa7.bin))
$(eval $(call PACKZX7B,lvl13_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl14_pack,src/niveles/mapaRa2.bin))
$(eval $(call PACKZX7B,lvl14_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl15_pack,src/niveles/mapaRa3.bin))
$(eval $(call PACKZX7B,lvl15_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl16_pack,src/niveles/dom7.bin))
$(eval $(call PACKZX7B,lvl16_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl17_pack,src/niveles/dom4.bin))
$(eval $(call PACKZX7B,lvl17_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl18_pack,src/niveles/dom10.bin))
$(eval $(call PACKZX7B,lvl18_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl19_pack,src/niveles/maf9.bin))
$(eval $(call PACKZX7B,lvl19_pack,src/comprimido))

$(eval $(call ADD2PACK,lvl20_pack,src/niveles/maf5.bin))
$(eval $(call PACKZX7B,lvl20_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl21_pack,src/niveles/maf6.bin))
$(eval $(call PACKZX7B,lvl21_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl22_pack,src/niveles/mapaRa1.bin))
$(eval $(call PACKZX7B,lvl22_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl23_pack,src/niveles/mapa6.bin))
$(eval $(call PACKZX7B,lvl23_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl24_pack,src/niveles/dom9.bin))
$(eval $(call PACKZX7B,lvl24_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl25_pack,src/niveles/maf1.bin))
$(eval $(call PACKZX7B,lvl25_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl26_pack,src/niveles/maf10.bin))
$(eval $(call PACKZX7B,lvl26_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl27_pack,src/niveles/mapaRa9.bin))
$(eval $(call PACKZX7B,lvl27_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl28_pack,src/niveles/dom3.bin))
$(eval $(call PACKZX7B,lvl28_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl29_pack,src/niveles/dom5.bin))
$(eval $(call PACKZX7B,lvl29_pack,src/comprimido))

$(eval $(call ADD2PACK,lvl30_pack,src/niveles/maf12.bin))
$(eval $(call PACKZX7B,lvl30_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl31_pack,src/niveles/maf3.bin))
$(eval $(call PACKZX7B,lvl31_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl32_pack,src/niveles/maf4.bin))
$(eval $(call PACKZX7B,lvl32_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl33_pack,src/niveles/mapaRa11.bin))
$(eval $(call PACKZX7B,lvl33_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl34_pack,src/niveles/dom1.bin))
$(eval $(call PACKZX7B,lvl34_pack,src/comprimido))
#$(eval $(call ADD2PACK,lvl35_pack,src/niveles/maf7.bin))
#$(eval $(call PACKZX7B,lvl35_pack,src/comprimido))
#$(eval $(call ADD2PACK,lvl36_pack,src/niveles/fullflechas.bin))
#$(eval $(call PACKZX7B,lvl36_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl35_pack,src/niveles/dom2.bin))
$(eval $(call PACKZX7B,lvl35_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl36_pack,src/niveles/dom8.bin))
$(eval $(call PACKZX7B,lvl36_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl37_pack,src/niveles/maf8.bin))
$(eval $(call PACKZX7B,lvl37_pack,src/comprimido))

$(eval $(call ADD2PACK,lvl38_pack,src/niveles/maf11.bin))
$(eval $(call PACKZX7B,lvl38_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl39_pack,src/niveles/mapaRa10.bin))
$(eval $(call PACKZX7B,lvl39_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl40_pack,src/niveles/mix1.bin))
$(eval $(call PACKZX7B,lvl40_pack,src/comprimido))
$(eval $(call ADD2PACK,lvl41_pack,src/niveles/dom6.bin))
$(eval $(call PACKZX7B,lvl41_pack,src/comprimido))


############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macros used for compression are ADD2PACK and PACKZX7B:                 ##
##                                                                        ##
##	ADD2PACK: Adds files to packed (compressed) groups. Each call to this ##
##  		  macro will add a file to a named compressed group.          ##
##  PACKZX7B: Compresses all files in a group into a single binary and    ##
##            generates a C-array and a header to comfortably use it from ##
##            inside your code.                                           ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call ADD2PACK,<packname>,<file>))                            ##
##                                                                        ##
##		Sequentially adds <file> to compressed group <packname>. Each     ##
## call to this macro adds a new <file> after the latest one added.       ##
## packname could be any valid C identifier.                              ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname): Name of the compressed group where the file will be added ##
##  (file)    : File to be added at the end of the compressed group       ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call PACKZX7B,<packname>,<dest_path>))                       ##
##                                                                        ##
##		Compresses all files in the <packname> group using ZX7B algorithm ##
## and generates 2 files: <packname>.c and <packname>.h that contain a    ##
## C-array with the compressed data and a header file for declarations.   ##
## Generated files are moved to the folder <dest_path>.                   ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname) : Name of the compressed group to use for packing          ##
##  (dest_path): Destination path for generated output files              ##
##                                                                        ##
############################################################################
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################
