;---------------------------LICENSE NOTICE------------------------------------
;  This file is part of Jungle Jump: An Amstrad CPC Videogame 
;  Copyright (C) 2020 Roberto García-Verdugo Sánchez / Rafael Eduardo Bayón Azócar/ Francisco Noguera Vidal
;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program.  If not, see <http://www.gnu.org/licenses/>.

.include "cpctelera.h.s"
.include "manager/entity.h.s"
.include "system/render.h.s"
.include "system/physics.h.s"
.include "manager/menu.h.s"
.include "manager/game.h.s"
.include "manager/transicion.h.s"
.include "manager/mapa.h.s"
.include "manager/interrupt.h.s"
.include "definitiva_xd.h.s"
.area _DATA
.area _CODE

.globl cpct_disableFirmware_asm
.globl cpct_isAnyKeyPressed_asm
.globl cpct_scanKeyboard_asm
.globl cpct_scanKeyboard_if_asm
.globl cpct_isKeyPressed_asm
.globl cpct_waitVSYNC_asm
.globl _reset
.globl _reinicio
.globl cpct_akp_musicPlay_asm
.globl cpct_akp_musicInit_asm
.globl cpct_akp_stop_asm
.globl cpct_setPALColour_asm

_reset::
   call menu_init
   call menu_run
   ;call cpct_akp_musicPlay_asm
   call mapa_init
   call game_init

   ;call render_mono
   ret

_reinicio::
   call entity_destroy
   call game_init
   call render_delete
   jr z, loop
   ret



_main::
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   call man_ir_init
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

   ;; Disable firmware to prevent it from interfering with string drawing
   ;call cpct_disableFirmware_asm         
   ld de, #_main_music
   call cpct_akp_musicInit_asm
   call _reset

   ;call entity_forall
   ;call physics_flecha

   ;; Loop forever   
loop:
   call game_update
   ;call cpct_scanKeyboard_asm
   ld hl, #Key_Esc
   call cpct_isKeyPressed_asm
   jr z, continue 
   call menu_init
   call menu_run
   ld hl, #nivel_ptr
   ld (hl), #0
   call _reinicio
   ;;
   continue:
     call cpct_waitVSYNC_asm
   jr    loop
