;---------------------------LICENSE NOTICE------------------------------------
;  This file is part of Jungle Jump: An Amstrad CPC Videogame 
;  Copyright (C) 2020 Roberto García-Verdugo Sánchez / Rafael Eduardo Bayón Azócar/ Francisco Noguera Vidal
;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program.  If not, see <http://www.gnu.org/licenses/>.

;;TIPOS
;;      Personaje = 01
;;      Enemigo   = 02
;;ESTADOS
;;      Vivo      = 01
;;      Muerto    = 02

.include "entity.h.s"
.include "cpctelera.h.s"
.include "../system/physics.h.s"
.include "../system/render.h.s"
.include "../system/collision.h.s"

_num_entities:: .db 0
;_puntero_array:: .dw entities_array         ;Puntero que señala al array de entidades
;entities_array::                            ;Array de punteros a entidades
    ;.ds max_entities * 2
entities_1st_free:: .dw entities_storage
entities_storage::  
   .ds max_entities * sizeof_e

entities_storage_size = max_entities * sizeof_e
entities_storage_aux::
    .ds max_entities * sizeof_e
entities_ptr_next:: .dw entities_storage
_inicialXflecha:: .db 0
_inicialXflecha2:: .db 0
_inicialXflecha3:: .db 0
;_inicialXflecha4:: .db 0
;_inicialXflecha5:: .db 0


entity_init::
    ;Reset entities
    ld hl, #entities_storage_aux
    ld de, #entities_storage
    ld bc, #entities_storage_size
    ldir
    ;;****************LLENAR DE 0 EL ARRAY DE ENTIDADES****************;;
    ;ld hl, #entities_array
    ;ld (_puntero_array), hl

    ;xor a
    ;ld (hl), a
    ;ld d, h
    ;ld e, l
    ;inc de
    ;ld bc, #2*max_entities-1

    ;ldir

    ;ld hl, #entities_array
    ret
entity_add::
    ;ld hl, (_puntero_array)
    ;ld__a_ixl
    ;ld (hl), a
    ;inc hl
    ;ld__a_ixh
    ;ld (hl), a

    ;inc hl
    ;ld (_puntero_array), hl
    ret

entity_create::
    ld de, (entities_1st_free)
    ld bc, #sizeof_e
    ldir

    ld a, (_num_entities)
    inc a
    ld (_num_entities), a

    ;Comprobar si es tipo flecha
    ;ld ix, (entities_1st_free)
    
    ;;******************************;;

    ;sigo:
    ld ix, (entities_1st_free)
    ld hl, (entities_1st_free)
    ld bc, #sizeof_e
    add hl, bc
    ld (entities_1st_free), hl

    ret

entity_destroy::
    ;borramos todas las entidades de _num_entities
    ;Faltaria hacer el borrado de entidad por entidad 
    miniloop:
        ld a, (_num_entities)
        dec a
        ld (_num_entities), a
        jr nz, miniloop
    ld hl, #entities_storage
    ld (entities_1st_free), hl
    ret


entity_set4destruction::
    ret

entity_ldix::
    ld ix, #entities_storage
ret

entity_forall::
    call entity_ldix
    ld (entities_ptr_next), ix
    ld a, #max_entities
    ld e, #max_entities
    bucleentidades:
        ld iy, (entities_ptr_next)
        ld d, e_tipo(iy)            ;Metemos el tipo de la entidad
        inc d
        dec d
        jr z, fin
        dec d                   
        jr nz, flecha               ;Si no es 0, quiere decir que es una entidad que no es el MONO

        ld hl, (entities_ptr_next)
        ld bc, #sizeof_e
        add hl, bc
        ld  (entities_ptr_next), hl
        dec e
        jr z, fin
        dec a
        jr nz, bucleentidades

        flecha:                     ;Nos guardamos su posicion en IX, para mas adelante poder modificarla
        ld d, e_tipo(iy) 
        dec d
        dec d
        jr nz, platano              ;Si no es 0 la segunda vez que restamos 1 a D, quiere decir que es platano
        ;TENGO QUE HACER UN CONTADOR QUE CUANDO CREE UNA FLECHA, LE ASIGNE FLECHA1, FLECHA2, ETC Y COMPROBAR QUE FLECHA
        ;ES ANTES DE RENDERIZAR 
        ld iy, (entities_ptr_next)
        push af

        ld a, e_numeroF(iy);Aqui sacamos el numero de flecha que es
        dec a
        jr z, ActionFlecha
        dec a
        jr z, ActionFlecha
        dec a
        jr z, ActionFlecha
        ;dec a
        ;jr z, ActionFlecha
        ;dec a
        ;jr z, ActionFlecha

        ActionFlecha:
            call physics_flecha
            call render_flecha
            call collision_check
            ld hl, (entities_ptr_next)
            ld bc, #sizeof_e
            add hl, bc
            ld  (entities_ptr_next), hl

        pop af
        dec e
        jr z, fin
        dec a
        jr nz, bucleentidades

        platano:
        ld iy, (entities_ptr_next)
        push af
        ;physics
        ld a, e_estado(iy)
        inc a
        dec a
        jr z, NOrenderizarPlatano

        call render_platano
        call collision_check
        ;Si el estado del platano es 0 quiere decir que esta borrado
        NOrenderizarPlatano:
            ld a, e_cien(iy)
            sub #50
            jr z, destruirCien
    
            ld a, e_cien(iy)
            inc a
            dec a
    
            jr z, NoDibujarCien
                call render_update_cien
            jr NoDibujarCien

        destruirCien:
            call render_delete_cien
        NoDibujarCien:
        ld hl, (entities_ptr_next)
        ld bc, #sizeof_e
        add hl, bc
        ld  (entities_ptr_next), hl
        pop af
        dec e
        jr z, fin
        dec a
        jp nz, bucleentidades

fin:

ret

entity_devuelve_flechaX::
    ld a, (_inicialXflecha)
ret
entity_devuelve_flechaX2::
    ld a, (_inicialXflecha2)
ret

entity_devuelve_flechaX3::
    ld a, (_inicialXflecha3)
ret

;entity_devuelve_flechaX4::
;    ld a, (_inicialXflecha4)
;ret
;entity_devuelve_flechaX5::
;    ld a, (_inicialXflecha5)
;ret

;en estas funciones meto en IY los 2 bloques creados. La colision solo esta activa con el primer bloque
entity_devuelvebloque::
    ld iy, #entities_storage + sizeof_e
    ret

entity_devuelve_otro_bloque::
    ld iy, #entities_storage + sizeof_e * 2
    ret
entity_delete_platano::
    
ret

entity_getInicialXflecha::
    ld hl, #_inicialXflecha
ret
entity_getInicialXflecha2::
    ld hl, #_inicialXflecha2
ret

entity_getInicialXflecha3::
    ld hl, #_inicialXflecha3
ret

;entity_getInicialXflecha4::
;    ld hl, #_inicialXflecha4
;ret
;entity_getInicialXflecha5::
;    ld hl, #_inicialXflecha5
;ret

entity_comprobarVariable::
    ld a, e_tipo(ix)
    dec a
    jr nz, meterVariable

    meterVariable:
        dec a
        jr nz, sigo
        ld a, e_numeroF(ix)
        dec a
        jr z, flecha1
        dec a
        jr z, flecha2
        dec a
        jr z, flecha3
        ;dec a
        ;jr z, flecha4
        ;dec a
        ;jr z, flecha5
        flecha1:
            ld a, e_x(ix)
            ld (_inicialXflecha), a
            jr sigo
        flecha2:
            ld a, e_x(ix)
            ld (_inicialXflecha2), a
            jr sigo
        flecha3:
            ld a, e_x(ix)
            ld (_inicialXflecha3), a
            jr sigo
        ;flecha4:
        ;    ld a, e_x(ix)
        ;    ld (_inicialXflecha4), a
        ;    jr sigo
        ;flecha5:
        ;    ld a, e_x(ix)
        ;    ld (_inicialXflecha5), a
        ;    jr sigo
    sigo:
ret