;---------------------------LICENSE NOTICE------------------------------------
;  This file is part of Jungle Jump: An Amstrad CPC Videogame 
;  Copyright (C) 2020 Roberto García-Verdugo Sánchez / Rafael Eduardo Bayón Azócar/ Francisco Noguera Vidal
;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program.  If not, see <http://www.gnu.org/licenses/>.

.include "cpctelera.h.s"
.include "game.h.s"
.include "entity.h.s"
.include "cpct_functions.h.s"

.include "../system/render.h.s"
.include "../system/physics.h.s"
.include "../system/collision.h.s"
.include "mapa.h.s"

;decompress_buffer = 0x40
;levelmaxsize = 0x404
;decompress_buffer_end = 0x443
;tileset_ptr = decompress_buffer + 500
;tilemap_ptr = decompress_buffer + 0
;;           nombre     x,      y,      h,      w,      vx,     vy,     a_y,    T,  E,  dash,   a_x,    dashdir     numeroFlecha,   cien
DefineEntity mono,      6,      160,    14,     7,      0,      0,      0,      1,  1,   1,    0,      0,               0,          0  
DefineEntity flecha,   55,      140,    3,      4,     -1,      0,      0,      2,  0,   0,    0,      0,               1,          0
DefineEntity platano,   45,      120,    8,      4,      0,      0,      0,      3,  1,   0,    0,      0,              0,          0

;.globl _lvl1_pack_end
;.globl cpct_zx7b_decrunch_s_asm
;.globl _tiles_00
;.globl _lvl1


game_init::

    call render_init
    call entity_init
    call mapa_draw

  ;ld hl, #_lvl1_pack_end
  ;call cpct_zx7b_decrunch_s_asm
;
    ;;dibujado tilemap
;
    ;;creacion entidades
    ld hl, #mono
    call entity_create

    ;Flecha1
    ;call game_createFlecha
    ;ld e_x(ix), #44
    ;ld e_y(ix), #129
    ;ld e_numeroF(ix), #1
    ;call entity_comprobarVariable
    ;call entity_getInicialXflecha
    ;ld (hl), #44
    ;;Flecha2
    ;call game_createFlecha
    ;ld e_x(ix), #55
    ;ld e_y(ix), #100
    ;ld e_numeroF(ix), #2
    ;call entity_comprobarVariable
    ;call entity_getInicialXflecha2
    ;ld (hl), #55
    ;;Flecha3
    ;call game_createFlecha
    ;ld e_x(ix), #60
    ;ld e_y(ix), #35
    ;ld e_numeroF(ix), #3
    ;call entity_comprobarVariable   
    ;call entity_getInicialXflecha3
    ;ld (hl), #60

    ;call game_createPlatano
    ;    ld e_x(ix), #16
    ;    ld e_y(ix), #40
    ;    ret


    call game_checknivel

ret

game_update::
    call physics_update
    ;call entity_forall
    call physics_update_flecha
    call render_update
    ret

game_checknivel::
    ;;comprobacion del nivel
    ld hl, #nivel_ptr
    ld a, (hl)
    sub #2
    jp z, nivel2
    sub #2
    jp z, nivel4
    sub #2
    jp z, nivel6
    sub #4
    jp z, nivel10
    dec a
    jp z, nivel11
    dec a
    jp z, nivel12
    dec a
    jp z, nivel13
    dec a
    jp z, nivel14
    dec a
    jp z, nivel15
    sub #2
    jp z, nivel17
    dec a
    jp z, nivel18
    dec a
    jp z, nivel19
    sub #2
    jp z, nivel21
    dec a
    jp z, nivel22
    sub #2
    jp z, nivel24
    dec a
    jp z, nivel25
    dec a
    jp z, nivel26
    dec a
    jp z, nivel27
    dec a
    jp z, nivel28
    sub #2
    jp z, nivel30
    dec a
    jp z, nivel31
    dec a
    jp z, nivel32
    dec a
    jp z, nivel33
    dec a
    jp z, nivel34
    sub #3
    jp z, nivel37
    dec a
    jp z, nivel38
    sub #2
    jp z, nivel40
    dec a
    jp z, nivel41

    ret
    
    ;;creacion de entidades pertinentes
    nivel2:
        call game_createPlatano
        ld e_x(ix), #64
        ld e_y(ix), #24
        ret
    nivel4:
        call game_createPlatano
        ld e_x(ix), #68
        ld e_y(ix), #160
        ret
    nivel6:
        call game_createPlatano
        ld e_x(ix), #8
        ld e_y(ix), #16
        ret
    nivel10:
        ;Flecha1
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #99
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #60
        ld e_y(ix), #171
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #60
        ret
    nivel11:
        ;Flecha1
        call game_createFlecha
        ld e_x(ix), #60
        ld e_y(ix), #43
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #60
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #44
        ld e_y(ix), #131
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #44
        call game_createPlatano
        ld e_x(ix), #8
        ld e_y(ix), #40
        ret
    nivel12:
        ;Flecha1
        call game_createFlecha
        ld e_x(ix), #60
        ld e_y(ix), #99
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #60
        ret
    nivel13:
        ;Flecha1
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #99
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ret
    nivel14:
        ;Flecha1
        call game_createPlatano
        ld e_x(ix), #68
        ld e_y(ix), #19
        ret
    nivel15:
     ;Flecha1
        call game_createFlecha
        ld e_x(ix), #48
        ld e_y(ix), #43
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #48

        call game_createPlatano
        ld e_x(ix), #8
        ld e_y(ix), #32
        ret

    nivel17:
        ;Flecha1
        call game_createPlatano
        ld e_x(ix), #68
        ld e_y(ix), #160
        ret
    nivel18:
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #67
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #123
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #68
        ret
    
    nivel19:
        call game_createPlatano
        ld e_x(ix), #68
        ld e_y(ix), #64
        ret
    
    nivel21:
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #19
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #139
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #68
        ret
    
    nivel22:
        call game_createPlatano
        ld e_x(ix), #12
        ld e_y(ix), #32
        ret

    nivel24:
     call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #35
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #56
        ld e_y(ix), #131
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #56
        ret
    nivel25:
    call game_createFlecha
        ld e_x(ix), #36
        ld e_y(ix), #139
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #36
        ret
    nivel26:
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #51
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ret
    nivel27:
    call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #35
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #75
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #68

         call game_createPlatano
        ld e_x(ix), #8
        ld e_y(ix), #24
        ret

    nivel28:
    call game_createFlecha
         ld e_x(ix), #44
        ld e_y(ix), #67
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #44

    call game_createPlatano
       
        ld e_x(ix), #36
        ld e_y(ix), #55
        ret

    nivel30:
     call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #19
        
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
    ret

    nivel31:
    call game_createPlatano
        ld e_x(ix), #16
        ld e_y(ix), #112
        ret

    nivel32:
    call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #67
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #64
        ld e_y(ix), #123
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #64
        ret

    nivel33:
    call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #59
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createPlatano
        ld e_x(ix), #8
        ld e_y(ix), #16
        ret

    nivel34:
    call game_createPlatano
        ld e_x(ix), #20
        ld e_y(ix), #64
        ret

    nivel37:
    call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #75
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #115
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #68
        ret

    nivel38:
    call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #107
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ret

    nivel40:
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #67
        ld e_numeroF(ix), #1
        call entity_comprobarVariable
        call entity_getInicialXflecha
        ld (hl), #68
        ;Flecha2
        call game_createFlecha
        ld e_x(ix), #68
        ld e_y(ix), #147
        ld e_numeroF(ix), #2
        call entity_comprobarVariable   
        call entity_getInicialXflecha2
        ld (hl), #68
        ret

    nivel41:
    call game_createPlatano
        ld e_x(ix), #68
        ld e_y(ix), #160
        ret
ret

game_createPlatano::
    ld hl, #platano
    call entity_create
ret

game_createFlecha::
    ld hl, #flecha
    call entity_create
ret