;---------------------------LICENSE NOTICE------------------------------------
;  This file is part of Jungle Jump: An Amstrad CPC Videogame 
;  Copyright (C) 2020 Roberto García-Verdugo Sánchez / Rafael Eduardo Bayón Azócar/ Francisco Noguera Vidal
;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program.  If not, see <http://www.gnu.org/licenses/>.

.include "interrupt.h.s"
.include "cpctelera.h.s"
.globl cpct_waitVSYNC_asm
.globl cpct_akp_musicPlay_asm
.globl cpct_scanKeyboard_i_asm
man_ir_current_interrupt:: .db 6

man_ir_1::
   push af
   push bc
   push hl
   setNumIR 1
   setNextManIr man_ir_2
   ;cpctm_setBorder_asm HW_BLACK

   pop hl
   pop bc
   pop af
   ei
   reti

man_ir_2::
   push af
   push bc
   push hl
   setNumIR 2
   setNextManIr man_ir_3
   ;cpctm_setBorder_asm HW_WHITE
   pop hl
   pop bc
   pop af
   ei
   reti

man_ir_3::
   push af
   push bc
   push hl
   setNumIR 3
   setNextManIr man_ir_4
   ;cpctm_setBorder_asm HW_RED
   pop hl
   pop bc
   pop af
   ei
   reti

man_ir_4::
   push af
   push bc
   push de
   push hl
   exx
   ex af, af'
   push af
   push bc
   push de
   push hl

   setNumIR 4
   setNextManIr man_ir_5

   ;cpctm_setBorder_asm HW_BRIGHT_RED
   call cpct_akp_musicPlay_asm
   ;cpctm_setBorder_asm HW_YELLOW 
   call cpct_scanKeyboard_i_asm
   ;cpctm_setBorder_asm HW_WHITE

   pop hl
   pop de
   pop bc
   pop af
   exx
   ex af, af'
   pop hl
   pop de
   pop bc
   pop af
   ei
   reti

man_ir_5::
   push af
   push bc
   push hl
   setNumIR 5
   setNextManIr man_ir_6
   pop hl
   pop bc
   pop af
   ei
   reti
 
man_ir_6::
   push af
   push bc
   push hl
   setNumIR 6
   setNextManIr man_ir_1
   pop hl
   pop bc
   pop af
   ei
   reti

man_ir_init::
   im 1
   call cpct_waitVSYNC_asm
   halt
   halt
   call cpct_waitVSYNC_asm
   di
   ld a, #0xC3
   ld (0x38), a
   ld hl, #man_ir_1
   ld (0x39), hl
   ei
   ret