;---------------------------LICENSE NOTICE------------------------------------
;  This file is part of Jungle Jump: An Amstrad CPC Videogame 
;  Copyright (C) 2020 Roberto García-Verdugo Sánchez / Rafael Eduardo Bayón Azócar/ Francisco Noguera Vidal
;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program.  If not, see <http://www.gnu.org/licenses/>.

.include "mapa.h.s"
.include "cpct_functions.h.s"
.include "transicion.h.s"


mapa_init::

    ;;nivel = 0, inicial
    ld hl, #nivel_ptr
    ld (hl), #0

    ld hl, #_lvl0_pack_end ;; de momento no hay nivel 0 pero eso
    call mapa_decompress
;
    ;;dibujado tilemap
    ;call mapa_draw
ret


mapa_next::


    ;;no se si se puede hacer inc a (hl) pero supongamos que si
    ld hl, #nivel_ptr
    ld a, (hl)
    inc a
    ld (hl), a

    ;; para cada nivel habra que hacer esto el caso default es que no hay niveles por tanto se ha acabado el juego, llamar a mapa init.
    dec a
    jp z, nivel_1

    dec a
    jp z, nivel_2

    dec a
    jp z, nivel_3

    dec a
    jp z, nivel_4

    dec a
    jp z, nivel_5

    dec a
    jp z, nivel_6

    dec a
    jp z, nivel_7

    dec a
    jp z, nivel_8

    dec a
    jp z, nivel_9

    dec a
    jp z, nivel_10

    dec a
    jp z, nivel_11

    dec a
    jp z, nivel_12

    dec a
    jp z, nivel_13

    dec a
    jp z, nivel_14

    dec a
    jp z, nivel_15

    dec a
    jp z, nivel_16

    dec a
    jp z, nivel_17

    dec a
    jp z, nivel_18

    dec a
    jp z, nivel_19

    dec a
    jp z, nivel_20

    dec a
    jp z, nivel_21

    dec a
    jp z, nivel_22

    dec a
    jp z, nivel_23

    dec a
    jp z, nivel_24

    dec a
    jp z, nivel_25

    dec a
    jp z, nivel_26

    dec a
    jp z, nivel_27

    dec a
    jp z, nivel_28

    dec a
    jp z, nivel_29

    dec a
    jp z, nivel_30

    dec a
    jp z, nivel_31

    dec a
    jp z, nivel_32

    dec a
    jp z, nivel_33

    dec a
    jp z, nivel_34

    dec a
    jp z, nivel_35

    dec a
    jp z, nivel_36

    dec a
    jp z, nivel_37

    dec a
    jp z, nivel_38

    dec a
    jp z, nivel_39

    dec a
    jp z, nivel_40

    dec a
    jp z, nivel_41
    
    jp default
    ;; etcetera etcetera


    nivel_1:
        ld hl, #_lvl1_pack_end
        call mapa_decompress
        
    ret

    nivel_2:
        ld hl, #_lvl2_pack_end
        call mapa_decompress
    ret

    nivel_3:
        ld hl, #_lvl3_pack_end
        call mapa_decompress
    ret

    nivel_4:
        ld hl, #_lvl4_pack_end
        call mapa_decompress
    ret

    nivel_5:
        ld hl, #_lvl5_pack_end
        call mapa_decompress
    ret

    nivel_6:
        ld hl, #_lvl6_pack_end
        call mapa_decompress
    ret

    nivel_7:
        ld hl, #_lvl7_pack_end
        call mapa_decompress
    ret

    nivel_8:
        ld hl, #_lvl8_pack_end
        call mapa_decompress
    ret

    nivel_9:
        ld hl, #_lvl9_pack_end
        call mapa_decompress
    ret

    nivel_10:
        ld hl, #_lvl10_pack_end
        call mapa_decompress
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    nivel_11:
        ld hl, #_lvl11_pack_end
        call mapa_decompress
        
    ret

    nivel_12:
        ld hl, #_lvl12_pack_end
        call mapa_decompress
    ret

    nivel_13:
        ld hl, #_lvl13_pack_end
        call mapa_decompress
    ret

    nivel_14:
        ld hl, #_lvl14_pack_end
        call mapa_decompress
    ret

    nivel_15:
        ld hl, #_lvl15_pack_end
        call mapa_decompress
    ret

    nivel_16:
        ld hl, #_lvl16_pack_end
        call mapa_decompress
    ret

    nivel_17:
        ld hl, #_lvl17_pack_end
        call mapa_decompress
    ret

    nivel_18:
        ld hl, #_lvl18_pack_end
        call mapa_decompress
    ret

    nivel_19:
        ld hl, #_lvl19_pack_end
        call mapa_decompress
    ret

    nivel_20:
        ld hl, #_lvl20_pack_end
        call mapa_decompress
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    nivel_21:
        ld hl, #_lvl21_pack_end
        call mapa_decompress
        
    ret

    nivel_22:
        ld hl, #_lvl22_pack_end
        call mapa_decompress
    ret

    nivel_23:
        ld hl, #_lvl23_pack_end
        call mapa_decompress
    ret

    nivel_24:
        ld hl, #_lvl24_pack_end
        call mapa_decompress
    ret

    nivel_25:
        ld hl, #_lvl25_pack_end
        call mapa_decompress
    ret

    nivel_26:
        ld hl, #_lvl26_pack_end
        call mapa_decompress
    ret

    nivel_27:
        ld hl, #_lvl27_pack_end
        call mapa_decompress
    ret

    nivel_28:
        ld hl, #_lvl28_pack_end
        call mapa_decompress
    ret

    nivel_29:
        ld hl, #_lvl29_pack_end
        call mapa_decompress
    ret

    nivel_30:
        ld hl, #_lvl30_pack_end
        call mapa_decompress
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    nivel_31:
        ld hl, #_lvl31_pack_end
        call mapa_decompress
        
    ret

    nivel_32:
        ld hl, #_lvl32_pack_end
        call mapa_decompress
    ret

    nivel_33:
        ld hl, #_lvl33_pack_end
        call mapa_decompress
    ret

    nivel_34:
        ld hl, #_lvl34_pack_end
        call mapa_decompress
    ret

    nivel_35:
        ld hl, #_lvl35_pack_end
        call mapa_decompress
    ret

    nivel_36:
        ld hl, #_lvl36_pack_end
        call mapa_decompress
    ret

    nivel_37:
        ld hl, #_lvl37_pack_end
        call mapa_decompress
    ret

    nivel_38:
        ld hl, #_lvl38_pack_end
        call mapa_decompress
    ret

    nivel_39:
        ld hl, #_lvl39_pack_end
        call mapa_decompress
    ret

    nivel_40:
        ld hl, #_lvl40_pack_end
        call mapa_decompress
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    nivel_41:
        ld hl, #_lvl41_pack_end
        call mapa_decompress
    ret      

    ;;etcetera etcetera


    default:
    ;; no quedan niveles de momento volvemos al primero. pantalla de vicotria
    call transicion_endgame
    call mapa_init 
    ret



ret


mapa_draw::

    ;;establecer tileset
    ld c, #0x14
    ld b, #0x19
    ld de, #0x0014
    ld hl, #_tiles_00
    call cpct_etm_setDrawTilemap4x8_ag_asm
    
    ;;establecer tilemap
   ld hl, #0xC000
   ld de, #tilemap_ptr
   call cpct_etm_drawTilemap4x8_ag_asm

ret

mapa_decompress::
    ;; descomprimir en la poscion pertinente
    ;; necesita en hl el pack compreso
    ld de, #decompress_buffer_end
    call cpct_zx7b_decrunch_s_asm

ret
