
;---------------------------LICENSE NOTICE------------------------------------
;  This file is part of Jungle Jump: An Amstrad CPC Videogame 
;  Copyright (C) 2020 Roberto García-Verdugo Sánchez / Rafael Eduardo Bayón Azócar/ Francisco Noguera Vidal
;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program.  If not, see <http://www.gnu.org/licenses/>.

.include "collision.h.s"
.include "cpctelera.h.s"
.include "../manager/game.h.s"
.include "../manager/entity.h.s"
.include "../manager/cpct_functions.h.s"
.include "../manager/transicion.h.s"
.include "render.h.s"
.include "physics.h.s"
.include "../manager/mapa.h.s"
;;tengo en IX el personaje
;;tengo en IY el objeto

;.globl _lvl1

collision_check::

call entity_ldix
;call entity_devuelvebloque
;;comprobamos eje X primero
;;if (e_x(ix) + e_w(ix) - e_x(iy) < 0) no colision
    ld a, e_x(ix)
    add e_w(ix)
    sub e_x(iy)
    jr c, no_collision
    

;; if (e_x(iy) + e_w(iy) - e_x(ix) < 0) no colision
    ld a, e_x(iy)
    add e_w(iy)
    sub e_x(ix)
    jr c, no_collision
    

;;comprobamos ahora el eje Y
;;if (e_y(ix) + e_h(ix) - e_y(iy) < 0) no colision
    ld a, e_y(ix)
    add e_h(ix)
    sub e_y(iy)
    jr c, no_collision
   
    
;; if (e_y(iy) + e_h(iy) - e_y(ix) < 0) no colision
    ld a, e_y(iy)
    add e_h(iy)
    sub e_y(ix)
    jr c, no_collision
    
    ;si colisiona en ambos ejes hago...
    call render_delete
    ;ld e_x(ix), #20
    ;ld e_y(ix), #184
    ld a, e_tipo(iy)
    dec a
    dec a
    jr nz, platano
    call render_lose
    call _reinicio
    ret

    platano:
        ld e_estado(iy), #0x00 
        ld e_cien(iy), #0x01
        call render_delete_platano  
    ;ld a, #0xFF
    ;ld (0xC000), a 

    ret 
no_collision::
    ret
;
;collision_plat::
;call entity_ldix
;call entity_devuelve_otro_bloque
;;;comprobamos eje X primero
;;;if (e_x(ix) + e_w(ix) - e_x(iy) < 0) no colision
;;;colision por la derecha 
;    ld a, e_x(ix)
;    add e_w(ix)
;    sub e_x(iy)
;    jr c, _nada
;    
;
;;; if (e_x(iy) + e_w(iy) - e_x(ix) < 0) no colision
;    ld a, e_x(iy)
;    add e_w(iy)
;    sub e_x(ix)
;    jr c, _nada
;    
;
;;;comprobamos ahora el eje Y
;;;if (e_y(ix) + e_h(ix) - e_y(iy) < 0) no colision
;    ld a, e_y(ix)
;    add e_h(ix)
;    sub e_y(iy)
;    jr c, _nada
;   
;    
;;; if (e_y(iy) + e_h(iy) - e_y(ix) < 0) no colision
;    ld a, e_y(iy)
;    add e_h(iy)
;    sub e_y(ix)
;    jr c, _nada
;    
;    ;si colisiona en ambos ejes hago...
;    ld a, #0x01
;    ret
;
;    _nada:; sin colision    
;    ld a, #0x69
;
;ret
;
;;pinta_uno::
;;    ld a, #0x88
;;    ld (0xC000), a
;;    ret
;;
;;pinta_otros::
;;    ld a, #0x88
;;    ld (0xC800), a
;;    ret
;


collision_mapdownleft::
    call entity_ldix
    ld a, e_y(ix)
    add #13
    srl a
    srl a           ;;y/8
    srl a

    ld h, #0
    ld l, a

    add hl, hl ;x2
    add hl, hl ;x4

    ld d, h
    ld e, l

    add hl, hl ;x8
    add hl, hl ;x16

    add hl, de; x20


    ld a, e_x(ix)
    srl a   ;x/4
    srl a

    add_hl_a ;; hl = ancho * y/8 + x/4

    ld de, #tilemap_ptr
    add hl, de

    ld a,(hl) ;; 0 = aire, 

    and #0xF8
    jr nz, _colided ;; no 0 = bloque solido = colision

     ld a, (hl)
    dec a
    jr z, _win1
    ;; cero = aire no
    ld a, #0x02
    ret

    _colided: ;;colision a = 1
    ld a, (hl)
    sub #18
    jr nc, _lose1

    ld a, #0x01
    ret

    _win1:

    call render_win
    call cargar_transicion
    ret

    _lose1:
        sub #4
        jr z, _trap1
        call render_lose
       call _reinicio
       ret

       _trap1:
        ld a, #0x01                   ;;sustituir con reinicio de nivel
    ret

ret


collision_mapupright::
    call entity_ldix
    ld a, e_y(ix)
    dec a
    srl a
    srl a           ;;y/8
    srl a

    ld h, #0
    ld l, a

    add hl, hl ;x2
    add hl, hl ;x4

    ld d, h
    ld e, l

    add hl, hl ;x8
    add hl, hl ;x16

    add hl, de; x20


    ld a, e_x(ix)
    add #6
    srl a   ;x/4
    srl a

    add_hl_a ;; hl = ancho * y/8 + x/4

    ld de, #tilemap_ptr
    add hl, de

    ld a,(hl) ;; 0 = aire, comprobacion solidos, luego comprobar pinchos, por ultimo comprobar wincondition
                            ;; aire 1-7   win condition 2-3     Pinchos 17-20
    
    


    and #0xF8

    jr nz, _colided2 ;; HAY COLISION

    ld a, (hl)
    dec a
    jr z, _win2
    ;; NO HAY COLISION A = 2
    ld a, #0x02
    ret

    _colided2: ;;colision a = 1
    ld a, (hl)
    sub #18
    jr nc, _lose2

    ld a, #0x01
    ret

    _win2:
    call render_win
    call cargar_transicion
    ret

    _lose2:

        sub #4
        jr z, _trap2
        call render_lose
       call _reinicio
       ret

       _trap2:
        ld a, #0x01                   ;;sustituir con reinicio de nivel 
    ret

ret

collision_mapupleft::
    call entity_ldix
    ld a, e_y(ix)
    dec a
    srl a
    srl a           ;;y/8
    srl a

    ld h, #0
    ld l, a

    add hl, hl ;x2
    add hl, hl ;x4

    ld d, h
    ld e, l

    add hl, hl ;x8
    add hl, hl ;x16

    add hl, de; x20


    ld a, e_x(ix)
    srl a   ;x/4
    srl a

    add_hl_a ;; hl = ancho * y/8 + x/4

    ld de, #tilemap_ptr
    add hl, de

    ld a,(hl) ;; 0 = aire, 


    and #0xF8

    jr nz, _colided3 ;; HAY COLISION

     ld a, (hl)
    dec a
    jr z, _win3
    ;; NO HAY COLISION A = 2
    ld a, #0x02
    ret

    _colided3: ;;colision a = 1

    ld a, (hl)
    sub #18
    jr nc, _lose3
    
    ld a, #0x01
    ret

    _win3:

    call cargar_transicion
    ret

    _lose3:
        sub #4
        jr z, _trap3
        call render_lose
       call _reinicio
       ret

       _trap3:
        ld a, #0x01                   ;;sustituir con reinicio de nivel
    ret

ret

collision_mapdownright::
    call entity_ldix
    ld a, e_y(ix)
    add #13
    srl a
    srl a           ;;y/8
    srl a

    ld h, #0
    ld l, a

    add hl, hl ;x2
    add hl, hl ;x4

    ld d, h
    ld e, l

    add hl, hl ;x8
    add hl, hl ;x16

    add hl, de; x20


    ld a, e_x(ix)
    add #6
    srl a   ;x/4
    srl a

    add_hl_a ;; hl = ancho * y/8 + x/4

    ld de, #tilemap_ptr
    add hl, de

    ld a,(hl) ;; 0 = aire,  1/2 = meta


    and #0xF8

    jr nz, _colided4 ;; HAY COLISION

    ;; NO HAY COLISION A = 2
    ld a, (hl)
    dec a
    jr z, _win4
    ld a, #0x02
    ret

    _colided4: ;;colision a = 1

     ld a, (hl)
    sub #18
    jr nc, _lose4

  
    ld a, #0x01
    ret

    _win4:
        call render_win
        call cargar_transicion ;; sustituir con cambio de nivel.
    ret

    _lose4:

        sub #4
        jr z, _trap4
        call render_lose
       call _reinicio
       ret

       _trap4:
        ld a, #0x01                   ;;sustituir con reinicio de nivel
    ret
ret


