;---------------------------LICENSE NOTICE------------------------------------
;  This file is part of Jungle Jump: An Amstrad CPC Videogame 
;  Copyright (C) 2020 Roberto García-Verdugo Sánchez / Rafael Eduardo Bayón Azócar/ Francisco Noguera Vidal
;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program.  If not, see <http://www.gnu.org/licenses/>.

.include "physics.h.s"
.include "cpctelera.h.s"
.include "render.h.s"
.include "manager/entity.h.s"
.include "collision.h.s"

.globl cpct_isAnyKeyPressed_asm
.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm

physics_flecha::

    ;call entity_forall  ;Se supone que en IY esta la pos de la Flecha
    ;call entity_devuelvebloque
    call render_delete_flecha

    ld a, #screen_width + 1 ;; guardamos en el acumulador el tamaño de la pantalla
    sub e_w(iy)     ;; lo restamos al ancho

    ld c, a  ;; guardamos en c el resultado

    ld a, e_x(iy)
    add e_vx(iy)
    sub #4

    cp c ;;comprobar el bit de acarreo, si hay acarreo se sale de la pantalla y no hay que dibuar
    jr nc, _nopinta

    add #4
    ld e_x(iy), a
    jr _pinta

    _nopinta:
        ld a, e_numeroF(iy)
        dec a
        jr z, flecha1
        dec a
        jr z, flecha2
        dec a
        jr z, flecha3
        ;dec a
        ;jr z, flecha4
        ;dec a
        ;jr z, flecha5
        flecha1:
            call entity_devuelve_flechaX
            ld e_x(iy), a
            jr continuar
        flecha2:
            call entity_devuelve_flechaX2
            ld e_x(iy), a
            jr continuar
        flecha3:
            call entity_devuelve_flechaX3
            ld e_x(iy), a
            jr continuar
        ;flecha4:
        ;    call entity_devuelve_flechaX4
        ;    ld e_x(iy), a
        ;    jr continuar
        ;flecha5:
        ;    call entity_devuelve_flechaX5
        ;    ld e_x(iy), a
        ;    jr continuar

    _pinta:

continuar:
ret

physics_update_flecha::

    call entity_forall

ret

physics_check_keyboard::
    ;Ver si esta pulsando alguna tecla

    call cpct_scanKeyboard_asm

    call cpct_isAnyKeyPressed_asm ;;nada pulsado salimos.
    jr z, _next3

    

    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    jr z, _next0

    ld a, e_dash(ix)
    dec a
        jr nz, _next0   
        ld e_dash(ix), #0x02
        jr _next3

     
     

     _next0:
     ld hl, #Key_O
    call cpct_isKeyPressed_asm
    jr z, _next1 ;; no pulsada contiunar puls

    ;ld a, #screen_height - 16
    ;sub e_y(ix)
    ;jr z, _cmp2

    ;;call collision_plat
    ;dec a
    ;jr nz, _next1

    _cmp2:
    
    ld a, e_dash(ix)
    dec a
    dec a
    jr z, _next1
    dec a
    jr z, _next1

    call phys_suelo ;suelo= 1 , no suelo = 2
    dec a ;; 1-1 =0 
    jr nz, _next1  ; 

     ld a, e_ay(ix)
    inc a
    dec a
    jr nz, _next1

    ld e_vy(ix), #-1
    ld e_ay(ix),#-10


    _next1:
    ld hl, #Key_D
    call cpct_isKeyPressed_asm
    jr z, _next2

     ld e_vx(ix), #1


    
    _next2:
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr z, _next3
        ld e_vx(ix), #-1



    _next3:

    call physics_dash

    call physics_air

    call physics_borders

    call physics_mapcol
    
    ret


physics_mapcol::
;; comprobamos derecha
    call collision_mapupright
    dec a
    jr nz, _izqup
    
     call phys_reposx
    call phys_reposy
   
        
        
        ret


    _izqup:

    call collision_mapupleft
    dec a
    jr nz, _izdown

;call phys_reposx
        call phys_reposx
        call phys_reposy
    
        
        
        ret


    _izdown:
     call collision_mapdownleft
    dec a
    jr nz, _ridown

        call phys_reposx
        call phys_reposy
         ;call phys_reposx
        
        ret


    _ridown:
     call collision_mapdownright
    dec a
    ret nz

        call phys_reposx
        call phys_reposy
        ;call phys_reposx
        ret




ret

physics_borders:: ;;comprobacion de los bordes, actualiza la la e_x y la e_y si esta bien 

    call render_delete

    ld a, #screen_width + 1 ;; guardamos en el acumulador el tamaño de la pantalla
    sub e_w(ix)     ;; lo restamos al ancho

    ld c, a  ;; guardamos en c el resultado

    ld a, e_x(ix)
    add e_vx(ix)
    
    cp c ;;comprobar el bit de acarreo, si hay acarreo se sale de la pantalla y no hay que dibuar
    jr nc, _nodrawx



    ;;guardamos la nueva x que luego se dibujara

    ld e_x(ix), a
    jr _drawx
    
    _nodrawx: ;;revertimos la suma

        ld a, e_vx(ix)
        neg 
        ld e_vx(ix) ,a 

    _drawx:


    ld a, #screen_height +1 ;; guardamos en el acumulador el tamaño de la pantalla
    sub e_h(ix)     ;; lo restamos al alto

    ld c, a  ;; guardamos en c el resultado

    ld a, e_y(ix)
    add e_vy(ix)
    

    cp c ;;comprobar el bit de acarreo, si hay acarreo se sale de la pantalla y no hay que dibuar
    jr nc, _nodrawy


        ld e_y(ix), a
        jr _draw

    _nodrawy: ;;revertimos la suma
        ld a, e_vy(ix)
        neg 
        ld e_vy(ix) ,a     
    _draw:


ret

phys_suelo:: ;; 1 si esta en el suelo 2 si no
    call collision_mapdownleft
    dec a
    jr nz, _checksig ;; esta en el aire.
    ld a, #2
    ret

    _checksig:
        inc e_y(ix) ;; bajamos 1 pixel el sprite, si esta en el suelo colisionara ahora
        call collision_mapdownright
        dec a
        jr z, _suelo ;; ahora si que ha colisionado por lo tanto esta en el suelo
        
        call collision_mapdownleft
        dec a
        jr z, _suelo
        ;; no esta en el suelo 
        dec e_y(ix);; devolvemos a su original
        ld a, #2
        ret

     _suelo:
         dec e_y(ix);; devolvemos a su original
         ld a, #1 ;; si esta en el suelo seguinosm
         ;call render_mono
         ret
ret


phys_reposy:: ;; si estamos aqui esque hemos colisionado reescribir ejes dependiendo de la aceleracion/velocidad

    ;ld b, #10
    ;;comprobamos la aceleracion ; negativa = subiendo positiva = bajando
    ld a, e_ay(ix)
    inc a
    dec a
    ret z ;; si la velocidad es 0 no ha sufrido cambios este eje no hay que hacer nada.
    jp p, _bajando

    _subiendo:
        ;ld b, #0
        inc e_y(ix) ;; incrementamos la y = bajamos el sprite hasta que no colisione
        call collision_mapupright
        dec a
        jr z, _checkupright
        jr _cnt_left

        _checkupright: ;; lo muevo a la izquierda, si a menos uno no hay colision quiere decir que esta tocando solo la esquina, no es suficiente como para cargarse la aceleracion
            dec e_y(ix)
            call collision_mapupright
            dec a
            push af
            inc e_y(ix)
            pop af
            inc a
            dec a
            jr z, _acc ;; sigue habiendo colision por tanto no es solo la esquina eliminamos acc
        
        _cnt_left:
        call collision_mapupleft
        dec a
        jr z, _checkupleft
        jr _bajando

        _checkupleft:
            dec e_y(ix)
            call collision_mapupleft
            dec a
            push af
            inc e_y(ix)
            pop af
            inc a
            dec a
            jr z, _acc ;; sigue habiendo coplision 
            ret
        _acc:
            ld e_ay(ix), #0
            jr _subiendo

       ; _tic:
       ; dec b
       ; jr nz, _subiendo
       ; ret
        
        
        ;ld e_vy(ix), #0

    
    _bajando: ;; decrementamos la y = subimos el sprite hasta que no colisione
        dec e_y(ix)
        call collision_mapdownleft
        dec a
        jr z, _bajando

        call collision_mapdownright
        dec a
        jr z, _bajando
        
        call phys_suelo
        dec a
        ret nz
        ld e_ay(ix), #0
        ret

       ; _toc:
       ; dec b
       ; jr nz, _bajando
       ; ret
        ;ld e_vy(ix), #0

ret

phys_reposx::

     ld a, e_vx(ix)
     inc a
     dec a
     ret z ;; si la velocidad es 0 no ha sufrido cambios este eje no hay que hacer nada.
     jp m, _izquierda

     _derecha:
     call collision_mapupright
     dec a
     jr nz, _sig

     ld a, e_x(ix)
     sub e_vx(ix)
     ld e_x(ix), a
     ld e_ax(ix), #0
     ld a, e_dash(ix)
     dec a
     jr nz, _resdash
     
     
     ret
    
    _sig:
    call collision_mapdownright
    dec a
    jr nz, _izquierda

     ld a, e_x(ix)
     sub e_vx(ix)
     ld e_x(ix), a
     ld e_ax(ix), #0
     ld a, e_dash(ix)
     dec a
     jr nz, _resdash
     
     ret

     _izquierda:
     call collision_mapupleft
     dec a
     jr nz, _sig2

     ld a, e_x(ix)
     sub e_vx(ix)
     ld e_x(ix), a  
     ld e_ax(ix), #0
     ld a, e_dash(ix)
     dec a
     jr nz, _resdash
     
     ret

    _sig2:
     call collision_mapdownleft
     dec a
     ret nz

     ld a, e_x(ix)
     sub e_vx(ix)
     ld e_x(ix), a
     ld e_ax(ix), #0
     ld a, e_dash(ix)
     dec a
     jr nz, _resdash
     ret

     _resdash:
        ld e_dash(ix), #0
        ret
  
ret


physics_update::

    call entity_ldix

    ld e_vx(ix), #0
    ld e_vy(ix), #0
    ;Llamar al check_keyboard para actualizar la posicion si se esta pulsando

    call physics_check_keyboard

    ;Solo se mueve si es del tipo input
ret

;;cuando screen y la poscion no sean iguales devolvemos un nz
physics_air::

    ld a, e_dash(ix)  ;; comprobar que no se ha iniciado el dash en ese turno dash =2, o esta en proceso dash = 3
    dec a
    dec a
    
    ret z
    dec a
    ret z

   call phys_suelo ;; comprobar que no esta en el suelo, phys suelo != 1
    dec a
    jr nz, aircnt

    ld a, e_ay(ix)
    inc a
    dec a
    ret z

        

    ;;esta en el aire , acelerancion +1 por iteracion

    aircnt:

    inc e_ay(ix)
    ld a, e_ay(ix)
    ld  e_vy(ix), a

    ;; maximo de aceleracion 10 hacia abajo
    ld a, e_ay(ix)
    sub #0x0A
    ret nz
        
    ld e_ay(ix), #9
ret


physics_dash::

    ld a, e_dash(ix)
    inc a
    dec a
    jr nz, _chkcontinue ;; noquedan dashes comprobar si estamos en el suelo para recargarlo

    call phys_suelo
    dec a
    jr z, _recarga ;; esta en el suelo recargar el dash y acabar
    ret
    ;call collision_plat
    ;dec a
    ;jr z, _recarga
    ;ret ;; no lo esta continuar caida

    _recarga:
        ld e_dash(ix), #1
        ret

    _chkcontinue::
    dec a
    ret z ;; dash 1 ->dash disponible pero no se ha ejecutado


    dec a
    jr z, _checkdir ;; dash 2, se ha ejecutado el dash en primera instancia tenemos que ver hacia donde va nuestro dash 


    dec a
    jr z, _linkerupdate;; dash 3, el dash esta en ejecucion y aun no ha acabado actualizar velocidades 


    ret


    _checkdir:

        call cpct_scanKeyboard_asm

        ld b, #0x88
        ld c, #0x88
        ;call render_mono

        push bc
        ;;checkeamos las teclas otra vez y lo guardamos en la velocidad.


        _cont0:

        ld hl, #Key_D
        call cpct_isKeyPressed_asm
        jr z, _cont1

        pop bc

         ld b, #2 ;;pulsada a la derecha b=2

        push bc

        _cont1:
        ld hl, #Key_A
        call cpct_isKeyPressed_asm
        jr z, _cont2

        pop bc
        ld b, #1 
        push bc

        _cont2:
        ld hl, #Key_W
        call cpct_isKeyPressed_asm
        jr z, _cont3

        pop bc
        ld c, #1
        push bc

        _cont3:
        ld hl, #Key_S
        call cpct_isKeyPressed_asm
        jr z, _cont4

        pop bc
        ld c, #2
        push bc

        _cont4: ;; comprobamos las teclas que han sido pulsadas. y la guardamos en la variable direccion de nuestro dash

        ;caso pulsar derecha
        ;ld a, b 
        pop bc

        dec b  ;;pulsada a la izquierda b =1 , 1-1 = 0, 
        jr z, _decX

        dec b ;pulsada a la derecha 2 -1 -1 =0 
        jr z, _incX

        jr _staticX


        _decX: ;; caso que se este pulsando la izquierda
            ld e_ax(ix), #-7
            ;ld a, c

            dec c
            jr z, _decY1 ;;comrpobar si arriba o abajo estan siendo pulsadas

            dec c
            jr z, _incY1


            jr _staticY1

            _decY1:    ;; actualizacion de direcion de nuestro personaje, activar tambien aceleraciones pertinentes
                ld e_dashdir(ix), #8
                ld e_ay(ix), #-14
                jr _flag

            _incY1:
                ld e_dashdir(ix), #6
                ld e_ay(ix), #14
                jr _flag

            _staticY1:
                ld e_dashdir(ix), #7
                ld e_ay(ix), #0
                jr _flag

        _linkerupdate:
            jr _updatedash

        _incX:
        ld e_ax(ix), #7
            ;ld a, c

            dec c
            jr z, _decY2

            dec c
            jr z, _incY2

            jr _staticY2

            _decY2:
                ld e_dashdir(ix), #2
                ld e_ay(ix), #-14
                jr _flag

            _incY2:
                ld e_dashdir(ix), #4
                ld e_ay(ix), #14
                jr _flag

            _staticY2:
                ld e_dashdir(ix), #3
                ld e_ay(ix), #0
                jr _flag


        _staticX:
        ld e_ax(ix), #0
            ;ld a, c
            dec c
            jr z, _decY3

            dec c 
            jr z, _incY3

            jr _staticY3

            _decY3:
                ld e_dashdir(ix), #1
                ld e_ay(ix), #-14
                jr _flag


            _incY3:
                ld e_dashdir(ix), #5
                ld e_ay(ix), #14
                jr _flag

            _staticY3:
                ld e_ax(ix), #7
                ld e_dashdir(ix), #3
                ld e_ay(ix), #0
                jr _flag



        _flag:
            ld e_dash(ix), #3
            ;call render_mono
            jr _updatedash

    _updatedash:
            ;; comprobar la direccion, inc/dec aceleraciones pertinentes
            ld a, e_dashdir(ix)
            dec a
            jr z, _dir1

            dec a
            jr z, _dir2

            dec a
            jr z, _dir3
    ;
            dec a
            jr z, _dir4
    ;
            dec a
            jr z, _dir5
    ;
            dec a
            jr z, _dir6
    ;
            dec a
            jr z, _dir7
    ;
            dec a
            jr z, _dir8

            ret ;; ninguna direccion valida, no hacer nada



            _dir2:
                inc e_ay(ix)
                inc e_ay(ix)
                ld a, e_ay(ix)
                ld e_vy(ix), a

                dec e_ax(ix)
                ld a, e_ax(ix)
                ld e_vx(ix), a

            jr _endash

              _dir1: ;;updateamos velocidades
                  inc e_ay(ix)
                inc e_ay(ix)
                ld a, e_ay(ix)
                ld e_vy(ix), a

                jr _endash

            _dir3:
                dec e_ax(ix)
                ld a, e_ax(ix)
                ld e_vx(ix), a

            jr _endash


            _dir4:
                dec e_ay(ix)
                dec e_ay(ix)
                ld a, e_ay(ix)
                ld e_vy(ix), a

                dec e_ax(ix)
                ld a, e_ax(ix)
                ld e_vx(ix), a

            jr _endash

            _linkerend:
                jr _endash

            _dir5:
                dec e_ay(ix)
                dec e_ay(ix)
                ld a, e_ay(ix)
                ld e_vy(ix), a

            jr _endash

            _dir6:
                dec e_ay(ix)
                dec e_ay(ix)
                ld a, e_ay(ix)
                ld e_vy(ix), a

                inc e_ax(ix)
                ld a, e_ax(ix)
                ld e_vx(ix), a

            jr _endash

            _dir7:
                inc e_ax(ix)
                ld a, e_ax(ix)
                ld e_vx(ix), a

            jr _endash

            _dir8:

                inc e_ax(ix)
                ld a, e_ax(ix)
                ld e_vx(ix), a

                inc e_ay(ix)
                inc e_ay(ix)
                ld a, e_ay(ix)
                ld e_vy(ix), a

            jr _endash

        _endash: ;; cuando las aceleraciones sean 0 cambiar el flag del dash a 0
        ld a, e_ax(ix)
        inc a
        dec a
        jr z, _finy

        ret
            _finy:
                ld a, e_ay(ix)
                inc a
                dec a
                jr z, _flagfin

                ret


        _flagfin:
                    ld e_dash(ix), #0

                    ret

ret