;---------------------------LICENSE NOTICE------------------------------------
;  This file is part of Jungle Jump: An Amstrad CPC Videogame 
;  Copyright (C) 2020 Roberto García-Verdugo Sánchez / Rafael Eduardo Bayón Azócar/ Francisco Noguera Vidal
;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;   the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program.  If not, see <http://www.gnu.org/licenses/>.

;Hacemos un update para que se vayan actualizando las entidades en pantalla y se dibujen.
.include "render.h.s"
.include "manager/entity.h.s"

.include "cpctelera.h.s"

.globl cpct_setPalette_asm
.globl cpct_getScreenPtr_asm
.globl cpct_setVideoMode_asm
.globl cpct_drawSprite_asm
.globl cpct_drawSolidBox_asm

.globl _rip_0
.globl _rip_1
.globl _rip_2
.globl _rip_3
.globl _win_0
.globl _win_1
.globl _win_2
.globl _win_3

render_init::
    ld c,#0
    call cpct_setVideoMode_asm

    cpctm_setBorder_asm HW_GREEN
    ld hl, #palette
    ld de, #16
    call cpct_setPalette_asm

    ;Limpiar memoria
   ld hl, #0xC000
   ld de, #0xC001
   ld bc, #0x4000-1
   ld (hl), #0
   ldir

ret

render_update_flecha::
    call entity_forall
ret

render_update_platano::
    call entity_forall
ret

render_flecha::
    ;call entity_devuelvebloque
    ;ld de, #0xC000
    ;
    ;ld b, e_y(iy)
    ;ld c, e_x(iy)
    ;call cpct_getScreenPtr_asm
;
    ;ex de, hl
    ;ld a, #0xFF
    ;ld c, e_w(iy)
    ;ld b, e_h(iy)
    ;call cpct_drawSolidBox_asm
    ;ret
;;;;;;;;;;;;;;;;;;;;;;;
    ;call entity_devuelvebloque
    ld de, #0xC000

    ld c, e_x(iy)
    ld b, e_y(iy)


    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    ld hl, #flecha_sprite
    
    ld c, e_w(iy)
    ld b, e_h(iy)
    call cpct_drawSprite_asm

ret

render_delete_flecha::
    ;call entity_devuelvebloque
    ld de, #0xC000
    
    ld b, e_y(iy)
    ld c, e_x(iy)
    call cpct_getScreenPtr_asm

    ex de, hl
    ld a, #0x00
    ld c, e_w(iy)
    ld b, e_h(iy)
    call cpct_drawSolidBox_asm
    
ret

render_platano::
    ;call entity_devuelve_otro_bloque
    ld de, #0xC000

    ld c, e_x(iy)
    ld b, e_y(iy)


    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    ld hl, #platano_sprite
    
    ld c, e_w(iy)
    ld b, e_h(iy)
    call cpct_drawSprite_asm
ret

render_delete_platano::
    ;call entity_devuelve_otro_bloque
    ld de, #0xC000
    
    ld b, e_y(iy)
    ld c, e_x(iy)
    call cpct_getScreenPtr_asm

    ex de, hl
    ld a, #0x00
    ld c, e_w(iy)
    ld b, e_h(iy)
    call cpct_drawSolidBox_asm

ret

render_cien::
    ld de, #0xC000

    ld c, e_x(iy)
    ld b, e_y(iy)
    ;ld a, #6
    ;sub a, b
    ;ld b, a

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    ld hl, #cien_sprite

    ld c, #5    ;w
    ld b, #4    ;h
    call cpct_drawSprite_asm
ret

render_delete_cien::
    ld de, #0xC000

    ld b, e_y(iy)
    ld c, e_x(iy)
    ;ld a, #6
    ;sub a, b
    ;ld b, a
    call cpct_getScreenPtr_asm

    ex de, hl
    ld a, #0x00
    ld c, #5
    ld b, #4
    call cpct_drawSolidBox_asm
ret

render_update_cien::
    call render_cien

    ;vale 1 al principio
    ld a, e_cien(iy)
    inc a
    ld e_cien(iy), a
    ;Hasta 10

    ;ld e_100(iy), #0x00

ret


;
;render_otrobloque::
;    call entity_devuelve_otro_bloque
;    ld de, #0xC000
;    
;    ld b, e_y(iy)
;    ld c, e_x(iy)
;    call cpct_getScreenPtr_asm
;
;    ex de, hl
;    ld a, #0x5c
;    ld c, e_w(iy)
;    ld b, e_h(iy)
;    call cpct_drawSolidBox_asm
;    ret

render_update::

    ld de, #0xC000

    ld c, e_x(ix)
    ld b, e_y(ix)


    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    ld hl, #mono_sprite
    
    ld c, e_w(ix)
    ld b, e_h(ix)
    call cpct_drawSprite_asm
    ret

;;ix posicion de mono
render_mono::
;
;call entity_ldix
;
;    ld de, #0xC000
;    ld b, #0x20
;    ld c, #0x20
;    call cpct_getScreenPtr_asm
;
;    ex de,hl ;intercambiar
;    ld hl, #mono_sprite
;    
;    ld bc, #0x1009
;
;
;    call cpct_drawSprite_asm
ret

render_move::
ret


render_delete::
    call entity_ldix

    ld de, #0xC000

    ld c, e_x(ix)
    ld b, e_y(ix)

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    ld a, #0x00
    ld c, e_w(ix)
    ld b, e_h(ix)
    
    call cpct_drawSolidBox_asm
ret

render_lose::
    call render_update
    
   

    ld de, #0xC000

    ld c, #0
    ld b, #55

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    
    ld hl, #_rip_0
    ld c, #20
    ld b, #13
    call cpct_drawSprite_asm

    ld de, #0xC000

    ld c, #20
    ld b, #55

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    
    ld hl, #_rip_1
    ld c, #20
    ld b, #13
    call cpct_drawSprite_asm


    ld de, #0xC000

    ld c, #40
    ld b, #55

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    
    ld hl, #_rip_2
    ld c, #20
    ld b, #13
    call cpct_drawSprite_asm


    ld de, #0xC000

    ld c, #60
    ld b, #55

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    
    ld hl, #_rip_3
    ld c, #20
    ld b, #13
    call cpct_drawSprite_asm

    ld a, #99999
    static:
    dec a
    halt
    halt
    ;halt
    ;push af
    jr nz, static
ret

render_win::
    call render_update
    
   

    ld de, #0xC000

    ld c, #0
    ld b, #55

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    
    ld hl, #_win_0
    ld c, #20
    ld b, #13
    call cpct_drawSprite_asm

    ld de, #0xC000

    ld c, #20
    ld b, #55

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    
    ld hl, #_win_1
    ld c, #20
    ld b, #13
    call cpct_drawSprite_asm


    ld de, #0xC000

    ld c, #40
    ld b, #55

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    
    ld hl, #_win_2
    ld c, #20
    ld b, #13
    call cpct_drawSprite_asm


    ld de, #0xC000

    ld c, #60
    ld b, #55

    call cpct_getScreenPtr_asm

    ex de,hl ;intercambiar
    
    ld hl, #_win_3
    ld c, #20
    ld b, #13
    call cpct_drawSprite_asm



    

    ld a, #99999
    static2:
    dec a
    halt
    halt
    ;halt
    ;push af
    jr nz, static2

ret